#include <QtGui>
#include <iostream>

using namespace std; 

//	class for test
class MyName
{
public :

	MyName(const QString name,int nid) { m_sname=name; m_nid=nid; };
	MyName(const MyName &other) { *this=other; };
	
	QString WhatYourName() const  { return m_sname; };
	int     WhatYourId()   const  { return m_nid; };
		
	MyName & operator =(const MyName &other) { m_sname=other.m_sname;m_nid=other.m_nid;return *this; };
	bool   operator<(const MyName &other) const { return (m_sname<other.WhatYourName()); };
	
private:
	QString m_sname;
	int m_nid;
};

//	dump list
void outputList(const char *title,QList<MyName> &plist )
{
	int ni;
	std::cout <<  title << std::endl;
	for(ni=0;ni<plist.count();ni++){
		std::cout << "[" <<  ni  << "]="<<  
			(const char*)plist.at(ni).WhatYourName().toAscii().data() << 
			"(" << 
			plist.at(ni).WhatYourId() <<
			")" << 
			std::endl;
	}
}

//	dump item
void outputItem(const char *title,QList<MyName>::iterator &pipos,QList<MyName>::iterator &pend )
{
	if(pend==pipos){
		pipos--;
		std::cout <<  title << "** last ** previous item --> "<< 
			(const char*)pipos->WhatYourName().toAscii().data() <<
			"(" << 
			pipos->WhatYourId() <<
			")" << 
			std::endl;
	} else {
		std::cout <<  title << 
			(const char*)pipos->WhatYourName().toAscii().data() <<
			"(" << 
			pipos->WhatYourId() <<
			")" << 
			std::endl;
	}
}

//	main
int main(int /* argc */, char* /*argv[]*/ )
{
	QList<MyName>::iterator ipos;
	QList<MyName> olist;
	MyName my1("test",1);
	MyName my12("test",2);
	MyName my13("test",3);
	MyName my2("taro",4);
	MyName my3("hanako",5);
	MyName my14("test1",6);
	olist.append(my1);
	olist.append(my12);
	olist.append(my13);
	olist.append(my2);
	olist.append(my3);
	olist.append(my14);
	

	MyName my_check("test",-1);

	outputList("Not Sort",olist);

	ipos=qUpperBound(olist.begin(),olist.end(),my_check);
	outputItem("[Not Sort(Upper)]",ipos,olist.end());

	ipos=qLowerBound(olist.begin(),olist.end(),my_check);
	outputItem("[Not Sort(Lower)]",ipos,olist.end());
	
	//	sort - qLess
	qSort(olist.begin(),olist.end(),qLess<MyName>());
	outputList("Sorted(qLess)",olist);
	
	ipos=qUpperBound(olist.begin(),olist.end(),my_check);
	outputItem("[Sorted(qLess)(Upper)]",ipos,olist.end());

	ipos=qLowerBound(olist.begin(),olist.end(),my_check);
	outputItem("[Sorted(qLess)(Lower)]",ipos,olist.end());
	
	//	sort - qGreater
	qSort(olist.begin(),olist.end(),qGreater<MyName>());
	
	outputList("Sorted(qGreater)",olist);
	
	ipos=qUpperBound(olist.begin(),olist.end(),my_check);
	outputItem("[Sorted(qGreater)(Upper)]",ipos,olist.end());

	ipos=qLowerBound(olist.begin(),olist.end(),my_check);
	outputItem("[Sorted(qGreater)(Lower)]",ipos,olist.end());
	
	return 0;
}

